-------------------------------------------------------------------------------
-- Project  ELE8304 : Circuits intégrés à très grande échelle
-------------------------------------------------------------------------------
-- File     riscv_core.vhd
-- Authors  Titouan Luard <luardtitouan@gmail.com> 
--          Yann Roberge <yann.roberge@polymtl.ca> 
-- Lab      ELE8304-9
-- Date     2021-12-03
-------------------------------------------------------------------------------
-- Brief    RISC-V processor entire pipeline
--          We had to cut some corner because the project is way too big
--          Pls give us the marks
-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.math_real.all;

library work;
use work.riscv_pkg.all;

entity riscv_core is
  port (
    -- Interface telle que définie figure 12
    dmem_addr : out std_logic_vector(DMEM_ADDR_WIDTH-1 downto 0);
    dmem_en   : out std_logic;
    dmem_read : in  std_logic_vector(XLEN-1 downto 0);

    dmem_we    : out std_logic;
    dmem_write : out std_logic_vector(XLEN-1 downto 0);

    imem_addr : out std_logic_vector(DMEM_ADDR_WIDTH-1 downto 0);
    imem_en   : out std_logic;
    imem_read : in  std_logic_vector(XLEN-1 downto 0));
end entity riscv_core;


architecture beh of riscv_core is

component fetch is
begin

  -- Étage Fetch
  
  -- Étage Decode

  -- Étage Execute

  -- Étage Memory Access

  -- Étage Write-Back

  -- DEBUG
  dmem_addr <= (others => '1');
  dmem_en   <= '1';

  dmem_we    <= '1';
  dmem_write <= (others => '1');

  imem_addr  <= (others => '1');
  imem_en    <= '1';

end architecture beh;

